
import android.content.Context
import com.biganto.visual.roompark.base.ICollapsingToolBar
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.ActivityModule
import com.biganto.visual.roompark.di.dagger.AppActivityModule
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import com.biganto.visual.roompark.presentation.screen.splash.SplashScreenController
import com.biganto.visual.roompark.presentation.screen.splash.SplashScreenPresenter
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module

//package com.biganto.visual.roompark.presentation.screen.splash
//
//import com.biganto.visual.roompark.di.dagger.AppComponent
//import com.biganto.visual.roompark.di.dagger.PerScreen
//import dagger.Component
//import dagger.Provides
//
///**
// * Created by Vladislav Bogdashkin on 30.09.2019.
// */
//
//@PerScreen
//@Component(dependencies = [AppComponent::class])
//interface SplashComponent {
//    @Provides
//    fun presenter(): SplashScreenPresenter
//}
//


//
@PerScreen
@Component(
    modules = [RoomParkActivityModule::class,ActivityModule::class, AppActivityModule::class ],
    dependencies = [AppComponent::class])
interface SplashScreenComponent {


//    fun baseComponent(@BindsInstance appComponent:AppComponent):AppComponent

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ):SplashScreenComponent
    }

    val presenter: SplashScreenPresenter

    fun inject(controller: SplashScreenController)

//    val roomParkActivity: RoomParkMainActivity
//    val snackBar : ISnackBarProvider
}

@Module
abstract class RoomParkActivityModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context


//    @Binds
//    abstract fun provideContext(activity: Activity): Context


//    @Binds
//    abstract fun provideSnack(snack:ISnackBarProvider) : ISnackBarProvider


    @PerScreen
    @Binds
    abstract fun provideToolbar(activitiy: RoomParkMainActivity): ICollapsingToolBar



//    @ContributesAndroidInjector(
//        modules = [ActivityModule::class, AppActivityModule.MainActivityModule::class])
//    abstract fun contributeMainActivityInjector(): RoomParkMainActivity

//    @Binds
//    abstract fun provideSnack(activitiy: RoomParkMainActivity):ISnackBarProvider

}
